#ifndef BatchLab_XML_Tree_h
#define BatchLab_XML_Tree_h

#include <BatchLab/Core/MemoryTree.h>

namespace Lib {class ItemML;}

namespace BatchLab {namespace XML {class Manager;}}

namespace BatchLab {

namespace XML {

class Tree : public MemoryTree {
public: //Slash::Core::IManager
  virtual void* cast(const std::string&) const;
public: //AIDA/ITree
  virtual bool commit();
  virtual bool close();
  virtual std::string storeName() const;
  virtual std::string storeType() const; //AIDA-v3r3p0
public:
  Tree(Slash::Core::ISession&,const std::string&,bool,bool,const std::string&,
           XML::Manager&,int);
  virtual ~Tree();
  bool isValid() const;
private:
  std::string buildName(Lib::ItemML&);
private:
  XML::Manager& fManager;
  std::string fStoreName;
  int fNameCounter;
  bool fReadOnly;
  bool fCreateNew;
  bool fCompress;
  bool fIsValid;
};

} //XML

} //BatchLab

#endif
