// this :
#include <BatchLab/Core/DataPointSetFactory.h>

#include <Lib/smanip.h>
#include <Lib/Debug.h>

#include <BatchLab/Core/DataPointSet.h>

//////////////////////////////////////////////////////////////////////////////
BatchLab::DataPointSetFactory::DataPointSetFactory(
 Slash::Core::IWriter& aPrinter
,Slash::Store::ITree& aTree
)
:BaseFactory(aPrinter,aTree)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("BatchLab::DataPointSetFactory");
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::DataPointSetFactory::~DataPointSetFactory(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::decrement("BatchLab::DataPointSetFactory");
}
#if (AIDA_VERSION_MAJOR<=3) && (AIDA_VERSION_MINOR<=2) 
//////////////////////////////////////////////////////////////////////////////
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::create(
 const std::string& aPath
,const std::string& aTitle
,int aDimensionOfPoints
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  std::string path,name,suffix;
  if(!Lib::smanip::pathNameSuffix(aPath,path,name,suffix)) return 0;
  BatchLab::DataPointSet* object = new BatchLab::DataPointSet(fPrinter,
                                                    name,aTitle,
                                                    aDimensionOfPoints);
  //if(!manage(aOptions)) return object;
  if(manageObject(object,path)) return object;
  delete object;
  return 0;
}
//////////////////////////////////////////////////////////////////////////////
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::create(
 const std::string& aPath
,int aDimensionOfPoints
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  std::string path,name,suffix;
  if(!Lib::smanip::pathNameSuffix(aPath,path,name,suffix)) return 0;
  BatchLab::DataPointSet* object = new BatchLab::DataPointSet(fPrinter,
                                                    name,name,
                                                    aDimensionOfPoints);
  //if(!manage(aOptions)) return object;
  if(manageObject(object,path)) return object;
  delete object;
  return 0;
}
#else
//////////////////////////////////////////////////////////////////////////////
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::create(
 const std::string& aPath
,const std::string& aTitle
,int aDimensionOfPoints
,const std::string& aOptions
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  std::string path,name,suffix;
  if(!Lib::smanip::pathNameSuffix(aPath,path,name,suffix)) return 0;
  BatchLab::DataPointSet* object = new BatchLab::DataPointSet(fPrinter,
                                                    name,aTitle,
                                                    aDimensionOfPoints);
  if(!manage(aOptions)) return object;
  if(manageObject(object,path)) return object;
  delete object;
  return 0;
}
//////////////////////////////////////////////////////////////////////////////
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::create(
 const std::string& aPath
,int aDimensionOfPoints
,const std::string& aOptions
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  std::string path,name,suffix;
  if(!Lib::smanip::pathNameSuffix(aPath,path,name,suffix)) return 0;
  BatchLab::DataPointSet* object = new BatchLab::DataPointSet(fPrinter,
                                                    name,name,
                                                    aDimensionOfPoints);
  if(!manage(aOptions)) return object;
  if(manageObject(object,path)) return object;
  delete object;
  return 0;
}
#endif

//FIXME
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createCopy(
 const std::string&
,const AIDA::IDataPointSet& ){ return 0;}

bool BatchLab::DataPointSetFactory::destroy(
 AIDA::IDataPointSet* ){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::create(
 const std::string&
,const AIDA::IHistogram1D&
,const std::string&){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::create(
 const std::string&
,const AIDA::IHistogram2D&
,const std::string&){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::create(
 const std::string&
,const AIDA::IHistogram3D&
,const std::string&){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::create(
 const std::string&
,const AIDA::ICloud1D&
,const std::string&){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::create(
 const std::string&
,const AIDA::ICloud2D&
,const std::string&){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::create(
 const std::string&
,const AIDA::ICloud3D&
,const std::string&){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::create(
 const std::string&
,const AIDA::IProfile1D&
,const std::string&){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::create(
 const std::string&
,const AIDA::IProfile2D&
,const std::string&){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::add(
 const std::string&
,const AIDA::IDataPointSet& 
,const AIDA::IDataPointSet& ){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::subtract(
 const std::string&
,const AIDA::IDataPointSet& 
,const AIDA::IDataPointSet& ){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::multiply(
 const std::string&
,const AIDA::IDataPointSet& 
,const AIDA::IDataPointSet& ){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::divide(
 const std::string&
,const AIDA::IDataPointSet& 
,const AIDA::IDataPointSet& ){ return 0;}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::weightedMean(
 const std::string&
,const AIDA::IDataPointSet& 
,const AIDA::IDataPointSet& ){ return 0;}



AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createX(
 const std::string& //aPath
,const std::string& //aTitle
,const std::vector<double>& //aXs
,const std::vector<double>& //aErrorXs
)
{
  return 0;
}
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createX(
 const std::string& //aPath
,const std::string& //aTitle
,const std::vector<double>& //aXs
,const std::vector<double>& //aErrorPlusXs
,const std::vector<double>& //aErrorMinusXs
)
{
  return 0;
}
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createX(
 const std::string& //aPathAndTitle
,const std::vector<double>& //aXs
,const std::vector<double>& //aErrorXs
)
{
  return 0;
}
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createX(
 const std::string& //aPathAndTitle
,const std::vector<double>& //aXs
,const std::vector<double>& //aErrorPlusXs
,const std::vector<double>& //aErrorMinusXs
)
{
  return 0;
}

AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createY(
 const std::string& //aPath
,const std::string& //aTitle
,const std::vector<double>& //aYs
,const std::vector<double>& //aErrorYs
)
{
  return 0;
}
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createY(
 const std::string& //aPath
,const std::string& //aTitle
,const std::vector<double>& //aYs
,const std::vector<double>& //aErrorPlusYs
,const std::vector<double>& //aErrorMinusYs
)
{
  return 0;
}
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createY(
 const std::string& //aPathAndTitle
,const std::vector<double>& //aYs
,const std::vector<double>& //aErrorYs
)
{
  return 0;
}
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createY(
 const std::string& //aPathAndTitle
,const std::vector<double>& //aYs
,const std::vector<double>& //aErrorPlusYs
,const std::vector<double>& //aErrorMinusYs
)
{
  return 0;
}


AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createXY(
 const std::string& //aPath
,const std::string& //aTitle
,const std::vector<double>& //aXs
,const std::vector<double>& //aYs
,const std::vector<double>& //aErrorXs
,const std::vector<double>& //aErrorYs
)
{
  return 0;
}
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createXY(
 const std::string& //aPath
,const std::string& //aTitle
,const std::vector<double>& //aXs
,const std::vector<double>& //aYs
,const std::vector<double>& //aErrorPlusXs
,const std::vector<double>& //aErrorPlusYs
,const std::vector<double>& //aErrorMinusXs
,const std::vector<double>& //aErrorMinusYs
)
{
  return 0;
}
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createXY(
 const std::string& //aPathAndTitle
,const std::vector<double>& //aXs
,const std::vector<double>& //aYs
,const std::vector<double>& //aErrorXs
,const std::vector<double>& //aErrorYs
)
{
  return 0;
}
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createXY(
 const std::string& //aPathAndTitle
,const std::vector<double>& //aXs
,const std::vector<double>& //aYs
,const std::vector<double>& //aErrorPlusXs
,const std::vector<double>& //aErrorPlusYs
,const std::vector<double>& //aErrorMinusXs
,const std::vector<double>& //aErrorMinusYs
)
{
  return 0;
}


AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createXYZ(
 const std::string& //aPath
,const std::string& //aTitle
,const std::vector<double>& //aXs
,const std::vector<double>& //aYs
,const std::vector<double>& //aZs
,const std::vector<double>& //aErrorXs
,const std::vector<double>& //aErrorYs
,const std::vector<double>& //aErrorZs
)
{
  return 0;
}
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createXYZ(
 const std::string& //aPath
,const std::string& //aTitle
,const std::vector<double>& //aXs
,const std::vector<double>& //aYs
,const std::vector<double>& //aZs
,const std::vector<double>& //aErrorPlusXs
,const std::vector<double>& //aErrorPlusYs
,const std::vector<double>& //aErrorPlusZs
,const std::vector<double>& //aErrorMinusXs
,const std::vector<double>& //aErrorMinusYs
,const std::vector<double>& //aErrorMinusZs
)
{
  return 0;
}
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createXYZ(
 const std::string& //aPathAndTitle
,const std::vector<double>& //aXs
,const std::vector<double>& //aYs
,const std::vector<double>& //aZs
,const std::vector<double>& //aErrorXs
,const std::vector<double>& //aErrorYs
,const std::vector<double>& //aErrorZs
)
{
  return 0;
}
AIDA::IDataPointSet* BatchLab::DataPointSetFactory::createXYZ(
 const std::string& //aPathAndTitle
,const std::vector<double>& //aXs
,const std::vector<double>& //aYs
,const std::vector<double>& //aZs
,const std::vector<double>& //aErrorPlusXs
,const std::vector<double>& //aErrorPlusYs
,const std::vector<double>& //aErrorPlusZs
,const std::vector<double>& //aErrorMinusXs
,const std::vector<double>& //aErrorMinusYs
,const std::vector<double>& //aErrorMinusZs
)
{
  return 0;
}
