// this :
#include <BatchLab/Core/Environment.h>

#include <Slash/Core/IWriter.h>

#include <Lib/System.h>
#include <Lib/Out.h>
#include <Lib/argZero.h>

//////////////////////////////////////////////////////////////////////////////
bool check_BATCHLABROOT(
 const std::string& aArg0
,Slash::Core::IWriter& aPrinter
,bool aWarn
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string fs = Lib::System::fileSeparator();
  std::string to = "Resources"+fs+"BatchLab";

  std::string dir_root;
  bool is_Mac_app;
  bool status = 
    Lib::argZero::checkEnv(aArg0,"BATCHLABROOT",to,aPrinter,false,
                        dir_root,is_Mac_app);

  if(status) {
    if(dir_root=="") {
      // Assume that BATCHLABROOT, SLASHROOT, LIBROOT, 
      // LIBDIRLIB, BATCHLABDIRLIB are defined through the dev setup.
      return true;
    } else {
      // Activated through an app in a OSC binary kit.
      // Have to define BATCHLABROOT.
    }
  } else {
    // May be activated from a user app that uses a OSC binary
    // kit and wants to use the on-the-fly-compilation-and-loading.
    // To detect this situation, we look for the AIDA_HOME_DIR 
    // that should be defined by the [aida-]setup of these kits.
    std::string AIDA_HOME_DIR;
    if(!Lib::System::getenv("AIDA_HOME_DIR",AIDA_HOME_DIR)) {
      Lib::Out out(aPrinter);
      out << "check_BATCHLABROOT :"
          << " cant guess where OpenScientist had been installed."
          << Lib::endl;
      return false;
    } else {
      dir_root = AIDA_HOME_DIR;
    }
  }

  if(!Lib::System::putenv
        ("BATCHLABROOT",dir_root+fs+"Resources"+fs+"BatchLab")) return false;

  // For the BatchLab/source/Core/FunctionCatalog.cxx and
  // BatchLab/scripts/[sh,DOS]/mak[c,f77]dll[.bat] :
  if(!Lib::System::putenv("SLASHROOT",dir_root+fs+"Resources"+fs+"Slash")) return false;
  if(!Lib::System::putenv("LIBROOT",dir_root+fs+"Resources"+fs+"Lib")) return false;
  if(!Lib::System::putenv("LIBDIRLIB",dir_root+fs+"lib")) return false;
  if(!Lib::System::putenv("BATCHLABDIRLIB",dir_root+fs+"lib")) return false;

  return true;
}
