// this :
#include <BatchLab/Core/Header.h>

#include <Slash/Store/IConstVisitor.h>
#include <Slash/Store/IVisitor.h>

#include <BatchLab/Version.h>
#include <AIDA/IConstants.h>

#include <Lib/Date.h>
#include <Lib/Cast.h>

//////////////////////////////////////////////////////////////////////////////
BatchLab::Header::Header(
)
:fPackage("BatchLab")
,fPackageVersion(BATCHLAB_VERSION)
,fAIDA_Version(AIDA_VERSION)
,fDate(Lib::Date::now())
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Header::~Header(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
void* BatchLab::Header::cast(
 const std::string& aClass
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if_Lib_SCast(Slash::Store::IStorable)
  else if_Lib_SCast(BatchLab::Header)
  else return 0;
}
SLASH_STORE_SOURCE(BatchLab::Header)
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Header::visit(
 Slash::Store::IConstVisitor& aVisitor
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SLASH_STORE_BEGIN(BatchLab::Header)

  int version = 1;
  if(!aVisitor.visit("fVersion",version)) return false;

  if(!aVisitor.visit("fPackage",fPackage)) return false;
  if(!aVisitor.visit("fPackageVersion",fPackageVersion)) return false;
  if(!aVisitor.visit("fAIDA_Version",fAIDA_Version)) return false;
  if(!aVisitor.visit("fDate",fDate)) return false;

  if(!aVisitor.end(*this)) return false;

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Header::read(
 Slash::Store::IVisitor& aVisitor
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!aVisitor.begin(*this)) return false;

  int version;
  if(!aVisitor.visit(version)) return false;

  if(!aVisitor.visit(fPackage)) return false;
  if(!aVisitor.visit(fPackageVersion)) return false;
  if(!aVisitor.visit(fAIDA_Version)) return false;
  if(!aVisitor.visit(fDate)) return false;

  if(!aVisitor.end(*this)) return false;
  return true;
}
