@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package HDF5 with version v1r165p5.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\build_osc_HDF5
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_HDF5_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_HDF5_path=%obuild_HDF5_path:~0,-12%

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

SET obuild_verbose=no
SET obuild_debug=no
SET obuild_optimize=yes
SET obuild_set_x=no

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug=yes
  SHIFT
  GOTO next_arg
:end_if_g

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF %obuild_debug% == yes SET obuild_optimize=no

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%" MKDIR "%obuild_HDF5_path%\%obuild_dir_bin%"

IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%" MKDIR "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_HDF5_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_HDF5_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_1
SET obuild_c_command=cl.exe
:end_if_platform_1
SET obuild_platform_result=
IF "%obuild_c_command%" == ""  ECHO Variable obuild_c_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_3
SET obuild_c_optimize=/O2
:end_if_platform_3
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_5
SET obuild_c_debug=/ZI /Od
:end_if_platform_5
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_7
SET obuild_c_options=/nologo /DWIN32 /MD /W3
:end_if_platform_7
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_lib_osc_HDF5_sh_8
  SET obuild_c_debug_local=%obuild_c_debug%
  GOTO end_if_db_build_lib_osc_HDF5_sh_8
:else_if_db_build_lib_osc_HDF5_sh_8
  SET obuild_c_debug_local=
:end_if_db_build_lib_osc_HDF5_sh_8

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_lib_osc_HDF5_sh_9
  SET obuild_c_optimize_local=%obuild_c_optimize%
  GOTO end_if_opt_build_lib_osc_HDF5_sh_9
:else_if_opt_build_lib_osc_HDF5_sh_9
  SET obuild_c_optimize_local=
:end_if_opt_build_lib_osc_HDF5_sh_9


FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_10
SET obuild_c_macros=%obuild_c_macros% /D_HDF5DLL_
:end_if_platform_10
SET obuild_platform_result=

IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%" MKDIR "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_HDF5_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_HDF5_path%\obuild\cpp\obuild_find.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r*`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r*`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r*`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

SET obuild_c_includes=/I"%obuild_HDF5_path%\include"
SET obuild_c_includes=%obuild_c_includes% /I"%obuild_zlib_path%\include"

IF EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\lib_osc_HDF5" RMDIR /S /Q "%obuild_HDF5_path%\%obuild_dir_bin%\lib_osc_HDF5"
IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\lib_osc_HDF5" MKDIR "%obuild_HDF5_path%\%obuild_dir_bin%\lib_osc_HDF5"

@IF %obuild_verbose% == yes @ECHO ON 
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5.obj "..\src\H5.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5A.obj "..\src\H5A.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5AC.obj "..\src\H5AC.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5B.obj "..\src\H5B.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5C.obj "..\src\H5C.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5D.obj "..\src\H5D.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Dcompact.obj "..\src\H5Dcompact.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Dcontig.obj "..\src\H5Dcontig.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Defl.obj "..\src\H5Defl.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Dio.obj "..\src\H5Dio.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Distore.obj "..\src\H5Distore.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Dmpio.obj "..\src\H5Dmpio.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Dselect.obj "..\src\H5Dselect.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Dtest.obj "..\src\H5Dtest.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5E.obj "..\src\H5E.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5F.obj "..\src\H5F.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FD.obj "..\src\H5FD.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FDcore.obj "..\src\H5FDcore.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FDfamily.obj "..\src\H5FDfamily.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FDgass.obj "..\src\H5FDgass.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FDlog.obj "..\src\H5FDlog.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FDmpi.obj "..\src\H5FDmpi.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FDmpio.obj "..\src\H5FDmpio.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FDmpiposix.obj "..\src\H5FDmpiposix.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FDmulti.obj "..\src\H5FDmulti.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FDsec2.obj "..\src\H5FDsec2.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FDsrb.obj "..\src\H5FDsrb.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FDstdio.obj "..\src\H5FDstdio.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FDstream.obj "..\src\H5FDstream.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FL.obj "..\src\H5FL.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FO.obj "..\src\H5FO.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5FS.obj "..\src\H5FS.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Fdbg.obj "..\src\H5Fdbg.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Fmount.obj "..\src\H5Fmount.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Fsfile.obj "..\src\H5Fsfile.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Fsuper.obj "..\src\H5Fsuper.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5G.obj "..\src\H5G.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Gent.obj "..\src\H5Gent.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Gnode.obj "..\src\H5Gnode.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Gstab.obj "..\src\H5Gstab.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5HG.obj "..\src\H5HG.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5HGdbg.obj "..\src\H5HGdbg.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5HL.obj "..\src\H5HL.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5HLdbg.obj "..\src\H5HLdbg.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5HP.obj "..\src\H5HP.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5I.obj "..\src\H5I.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5MF.obj "..\src\H5MF.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5MM.obj "..\src\H5MM.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5O.obj "..\src\H5O.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Oattr.obj "..\src\H5Oattr.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Obogus.obj "..\src\H5Obogus.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Ocont.obj "..\src\H5Ocont.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Odtype.obj "..\src\H5Odtype.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Oefl.obj "..\src\H5Oefl.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Ofill.obj "..\src\H5Ofill.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Olayout.obj "..\src\H5Olayout.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Omtime.obj "..\src\H5Omtime.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Oname.obj "..\src\H5Oname.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Onull.obj "..\src\H5Onull.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Opline.obj "..\src\H5Opline.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Osdspace.obj "..\src\H5Osdspace.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Oshared.obj "..\src\H5Oshared.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Ostab.obj "..\src\H5Ostab.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5P.obj "..\src\H5P.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Pdcpl.obj "..\src\H5Pdcpl.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Pdxpl.obj "..\src\H5Pdxpl.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Pfapl.obj "..\src\H5Pfapl.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Pfcpl.obj "..\src\H5Pfcpl.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Ptest.obj "..\src\H5Ptest.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5R.obj "..\src\H5R.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5RC.obj "..\src\H5RC.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5RS.obj "..\src\H5RS.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5S.obj "..\src\H5S.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5SL.obj "..\src\H5SL.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5ST.obj "..\src\H5ST.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Sall.obj "..\src\H5Sall.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Shyper.obj "..\src\H5Shyper.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Smpio.obj "..\src\H5Smpio.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Snone.obj "..\src\H5Snone.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Spoint.obj "..\src\H5Spoint.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Sselect.obj "..\src\H5Sselect.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Stest.obj "..\src\H5Stest.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5T.obj "..\src\H5T.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5TS.obj "..\src\H5TS.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tarray.obj "..\src\H5Tarray.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tbit.obj "..\src\H5Tbit.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tcommit.obj "..\src\H5Tcommit.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tcompound.obj "..\src\H5Tcompound.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tconv.obj "..\src\H5Tconv.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tcset.obj "..\src\H5Tcset.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tenum.obj "..\src\H5Tenum.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tfields.obj "..\src\H5Tfields.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tfixed.obj "..\src\H5Tfixed.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tfloat.obj "..\src\H5Tfloat.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tinit.obj "..\src\H5Tinit.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tnative.obj "..\src\H5Tnative.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Toffset.obj "..\src\H5Toffset.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Topaque.obj "..\src\H5Topaque.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Torder.obj "..\src\H5Torder.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tpad.obj "..\src\H5Tpad.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tprecis.obj "..\src\H5Tprecis.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tstrpad.obj "..\src\H5Tstrpad.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Tvlen.obj "..\src\H5Tvlen.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5V.obj "..\src\H5V.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Z.obj "..\src\H5Z.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Zdeflate.obj "..\src\H5Zdeflate.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Zfletcher32.obj "..\src\H5Zfletcher32.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Zshuffle.obj "..\src\H5Zshuffle.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5Zszip.obj "..\src\H5Zszip.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5IM.obj "..\src\hl\H5IM.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5LT.obj "..\src\hl\H5LT.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

cd "%obuild_HDF5_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_osc_HDF5\H5TA.obj "..\src\hl\H5TA.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HDF5_path%\obuild"

@IF %obuild_verbose% == yes @ECHO OFF 

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_128
SET obuild_c_linker_command=link.exe
:end_if_platform_128
SET obuild_platform_result=
IF "%obuild_c_linker_command%" == ""  ECHO Variable obuild_c_linker_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_130
SET obuild_c_linker_debug=/DEBUG
:end_if_platform_130
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_132
SET obuild_c_linker_options=/nologo
:end_if_platform_132
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_lib_osc_HDF5_sh_133
  SET obuild_c_linker_debug_local=%obuild_c_linker_debug%
  GOTO end_if_db_build_lib_osc_HDF5_sh_133
:else_if_db_build_lib_osc_HDF5_sh_133
  SET obuild_c_linker_debug_local=
:end_if_db_build_lib_osc_HDF5_sh_133

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_lib_osc_HDF5_sh_134
  SET obuild_c_linker_optimize_local=%obuild_c_linker_optimize%
  GOTO end_if_opt_build_lib_osc_HDF5_sh_134
:else_if_opt_build_lib_osc_HDF5_sh_134
  SET obuild_c_linker_optimize_local=
:end_if_opt_build_lib_osc_HDF5_sh_134

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_136
SET obuild_linked_paths=/LIBPATH:"%obuild_zlib_path%\%obuild_dir_bin%"
SET obuild_linked_libraries=osc_zlib.lib
:end_if_platform_136
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HDF5_0=%%d
cd "%obuild_HDF5_path%\%obuild_dir_bin%"
IF EXIST .\lib_osc_HDF5\tmp_objs DEL .\lib_osc_HDF5\tmp_objs
FOR %%f IN (.\lib_osc_HDF5\*.obj) DO ECHO %%f >> .\lib_osc_HDF5\tmp_objs

REM # Building the DLL :
IF EXIST .\osc_HDF5.dll DEL .\osc_HDF5.dll
@IF %obuild_verbose% == yes @ECHO ON 
link.exe /nologo /dll /out:.\osc_HDF5.dll @.\lib_osc_HDF5\tmp_objs %obuild_linked_paths% %obuild_linked_libraries% 1> link_exe_error
@IF ERRORLEVEL 1 @TYPE link_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL link_exe_error
@IF %obuild_verbose% == yes @ECHO OFF 

cd "%obuild_pwd_HDF5_0%"
SET obuild_pwd_HDF5_0=
REM # Some cleanup :
IF EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\lib_osc_HDF5\tmp_objs" DEL "%obuild_HDF5_path%\%obuild_dir_bin%\lib_osc_HDF5\tmp_objs"
IF EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\osc_HDF5.exp" DEL "%obuild_HDF5_path%\%obuild_dir_bin%\osc_HDF5.exp"

:obuild_return
ENDLOCAL
@ECHO ON
