
#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/System.h>
#include <Lib/Arguments.h>
#include <Lib/DLL.h>

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Printer printer;
  Lib::Out out(printer);

  Lib::Arguments args(aArgc,aArgv);

  if(args.isAnArgument("-h")) {
    out << "Lib_dld :" << Lib::endl;
    out << "Usage :" << Lib::endl;
    out << " OS> Lib_dld <options>" << Lib::endl;
    out << "Options :" << Lib::endl;
    out << " -dll=<string> : dll to open." << Lib::endl;
    out << " -symbol=<string> : symbol to search in the dll." << Lib::endl;
    out << " -verbose." << Lib::endl;
    out << " -h : to have help." << Lib::endl;
    out << "For example :" << Lib::endl;
    out << " OS> Lib_dld -dll=LibTest -symbol=Lib_Test_Init" << Lib::endl;
    return Lib::System::exitSuccess();
  }

  std::string dll;
  if(!args.find("-dll",dll)) {
    out << "Lib_dld :" << Lib::endl;
    out << " give a dll with -dll=<file>" << Lib::endl;
    return Lib::System::exitFailure();\
  }

  int verboseLevel = 0;
  if(args.isAnArgument("-verbose")) verboseLevel = 1;

 {// Put in a block to check the destruction.
   Lib::DLL module(dll,printer,verboseLevel);
  if(!module.isOpened()) return Lib::System::exitFailure();\

  std::string symbol;
  args.find("-symbol",symbol);

  if(symbol!="") {
    if(!module.findProcedure(symbol)) {
      return Lib::System::exitFailure();\
    }
  }}

  return Lib::System::exitSuccess();
}

// embed code :
#include <Printer.cxx>
#include <Out.cxx>
#include <System.cxx>
#include <Arguments.cxx>
#include <smanip.cxx>
#include <cmanip.cxx>
#include <sout.cxx>
#include <DLL.cxx>
#include <Debug.cxx>

