
// this :
#include <Lib/Arguments.h>

#include <Lib/smanip.h>

#include <string.h> //strcpy

//////////////////////////////////////////////////////////////////////////////
Lib::Arguments::Arguments(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib::Arguments::Arguments(
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<std::string> args;
  for(int index=0;index<aArgc;index++) args.push_back(aArgv[index]);
  add(args);
}
//////////////////////////////////////////////////////////////////////////////
Lib::Arguments::Arguments(
 const std::vector<std::string>& aArgs
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  add(aArgs);
}
//////////////////////////////////////////////////////////////////////////////
Lib::Arguments::Arguments(
 const std::string& aArgs
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<std::string> args;
  smanip::words(aArgs," ",args);  
  add(args);
}
//////////////////////////////////////////////////////////////////////////////
Lib::Arguments::Arguments(
 const std::vector<Argument>& aArgs
)
:fArgs(aArgs)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib::Arguments::Arguments(
 const Arguments& aFrom
)
:fArgs(aFrom.fArgs)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib::Arguments::~Arguments(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
unsigned int Lib::Arguments::number(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fArgs.size();
}
//////////////////////////////////////////////////////////////////////////////
const std::vector<Lib::Arguments::Argument>& Lib::Arguments::args(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fArgs;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Arguments::isAnArgument(
 const std::string& aString
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  unsigned int argn = fArgs.size();
  for(unsigned int index=0;index<argn;index++) {
    if(aString==fArgs[index].first) return true;
  }
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Arguments::add(
 const std::string& aKey
,const std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  unsigned int argn = fArgs.size();
  for(unsigned int index=0;index<argn;index++) {
    if(aKey==fArgs[index].first) {
      fArgs[index].second = aValue;
      return true;
    }
  }
  if(aKey=="") return false;
  fArgs.push_back(Argument(aKey,aValue)); 
  return true;
}
//////////////////////////////////////////////////////////////////////////////
int Lib::Arguments::remove(
 const std::string& aKey
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  // Brute force....
  std::vector<Argument> args;
  unsigned int argn = fArgs.size();
  for(unsigned int index=0;index<argn;index++) {
    if(aKey!=fArgs[index].first) args.push_back(fArgs[index]);
  }
  int number = fArgs.size() - args.size();
  fArgs = args;
  return number; //number of items removed.
}
//////////////////////////////////////////////////////////////////////////////
std::string Lib::Arguments::tostring(
 const std::string& aSeparator
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return Lib::smanip::tostring(tovector()," ");
}
//////////////////////////////////////////////////////////////////////////////
std::vector<std::string> Lib::Arguments::tovector(
) const
//////////////////////////////////////////////////////////////////////////////
// Return a vector of string <name=value>
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<std::string> vec(fArgs.size());
  unsigned int argn = fArgs.size();
  for(unsigned int index=0;index<argn;index++) {
    std::string s;
    if(fArgs[index].second=="") {
      s = fArgs[index].first;
    } else {
      s = fArgs[index].first;
      s += "=";
      s += fArgs[index].second;
    }
    vec[index] = s;
  }
  return vec;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Arguments::find(
 const std::string& aString
,std::string& aValue
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  unsigned int argn = fArgs.size();
  for(unsigned int index=0;index<argn;index++) {
    if(aString==fArgs[index].first) {
      aValue = fArgs[index].second;
      return true;
    }
  }
  aValue = "";
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Arguments::find(
 const std::string& aArg
,bool& aValue
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string svalue;
  if(!find(aArg,svalue)) {
    aValue = false;
    return false;
  }
  return Lib::smanip::tobool(svalue,aValue);
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Arguments::find(
 const std::string& aArg
,int& aValue
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string svalue;
  if(!find(aArg,svalue)) {
    aValue = 0;
    return false;
  }
  return Lib::smanip::toint(svalue,aValue);
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Arguments::find(
 const std::string& aArg
,unsigned int& aValue
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string svalue;
  if(!find(aArg,svalue)) {
    aValue = 0;
    return false;
  }
  return Lib::smanip::touint(svalue,aValue);
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Arguments::find(
 const std::string& aArg
,double& aValue
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string svalue;
  if(!find(aArg,svalue)) {
    aValue = 0;
    return false;
  }
  return Lib::smanip::todouble(svalue,aValue);
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Arguments::match(
 const std::string& aPattern
,std::string& aKey
,std::string& aValue
) const
//////////////////////////////////////////////////////////////////////////////
// aString may contains wildcards.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  aKey = "";
  aValue = "";
  unsigned int argn = fArgs.size();
  for(unsigned int index=0;index<argn;index++) {
    if(Lib::smanip::match(fArgs[index].first,aPattern)) {
      aKey = fArgs[index].first;
      aValue = fArgs[index].second;
      return true;
    }
  }
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Arguments::first(
 std::string& aName
,std::string& aValue
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  aName = "";
  aValue = "";
  if(!fArgs.size()) return false;
  aName = fArgs[0].first;
  aValue = fArgs[0].second;
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Arguments::last(
 std::string& aName
,std::string& aValue
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  aName = "";
  aValue = "";
  if(!fArgs.size()) return false;
  aName = fArgs[fArgs.size()-1].first;
  aValue = fArgs[fArgs.size()-1].second;
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Arguments::file(
 std::string& aFile
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string slast;
  std::string s;
  if((number()!=1) 
     && last(slast,s) 
     && (slast.find("-")!=0) 
     && (s=="") ) {
    aFile = slast; //Last argument is not an option.
    return true;
  } else {
    aFile = "";
    return false;
  }
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Arguments::knownOptions(
 const std::vector<std::string>& aOptions
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  unsigned int argn = fArgs.size();
  for(unsigned int index=0;index<argn;index++) {
    if(fArgs[index].first.find("-",0)==0) {
      bool found = false;
      unsigned int optn = aOptions.size();
      for(unsigned int opt=0;opt<optn;opt++) {
        if(fArgs[index].first==aOptions[opt]) {
          found = true;
          break;        
        }
      }
      if(!found) return false;
    }
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Arguments::add(
 const std::vector<std::string>& aArgs
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  unsigned int argc = aArgs.size();
  for(unsigned int index=0;index<argc;index++) {
    std::string s = aArgs[index];
    std::vector<std::string> words;
    smanip::words(s,"=",words);
    if(words.size()==1) {
      fArgs.push_back(Argument(words[0],"")); 
    } else if(words.size()>=2) {
      fArgs.push_back(Argument(words[0],words[1])); 
    }
  }
}
#include <string.h>
//////////////////////////////////////////////////////////////////////////////
void Lib::Arguments::argcv(
 int& aArgc
,char**& aArgv
) const
//////////////////////////////////////////////////////////////////////////////
// If using with :
//   int argc;
//   char** argv;
//   args.argcv(argc,argv);  
// delete with :
//  for(int index=0;index<argc;index++) delete [] argv[index];
//  delete [] argv;
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  aArgc = (int)fArgs.size();
  if(aArgc<=0) {
    aArgc = 0;
    aArgv = 0;
    return;
  }
  typedef char* cstring;
  aArgv = new cstring[aArgc];
  for(int index=0;index<aArgc;index++) {
    std::string arg = fArgs[index].first;
    if(fArgs[index].second!="") {
      arg += "=";
      arg += fArgs[index].second;
    }
    aArgv[index] = new char[arg.size()+1];
    ::strcpy(aArgv[index],arg.c_str());
  }
}
