
// this :
#include <Lib/BaseAccessor.h>

#include <Lib/Property.h>
#include <Lib/Value.h>
#include <Lib/Cast.h>
#include <Lib/Debug.h>

//////////////////////////////////////////////////////////////////////////////
Lib::BaseAccessor::BaseAccessor(
 Slash::Core::IWriter& aPrinter
)
:fPrinter(aPrinter)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("Lib::BaseAccessor");
}
//////////////////////////////////////////////////////////////////////////////
Lib::BaseAccessor::~BaseAccessor(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::decrement("Lib::BaseAccessor");
}
//////////////////////////////////////////////////////////////////////////////
void* Lib::BaseAccessor::cast(
 const std::string& aClass
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if_Lib_SCast(Lib::BaseAccessor)
  else if_Lib_SCast(Slash::Data::IAccessor)
  else return 0;
}
//////////////////////////////////////////////////////////////////////////////
unsigned int Lib::BaseAccessor::numberOfProperties(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fList.size();
}
//////////////////////////////////////////////////////////////////////////////
const Slash::Data::IProperty* Lib::BaseAccessor::property(
 unsigned int aIndex
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aIndex>=fList.size()) return 0;
  return &(fList[aIndex]);
}
//////////////////////////////////////////////////////////////////////////////
void Lib::BaseAccessor::addProperty(
 const std::string& aName
,Slash::Data::IProperty::Type aType
,int aHead
,const std::string& aLabel
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fList.push_back(Property(aName,aType,aHead,aLabel));
}
//////////////////////////////////////////////////////////////////////////////
Slash::Data::IIterator* Lib::BaseAccessor::iterator(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return 0;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::BaseAccessor::setName(
 const std::string&
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return false;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::BaseAccessor::setIterator(
 Slash::Data::IIterator* 
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
}
//////////////////////////////////////////////////////////////////////////////
void Lib::BaseAccessor::setIteratorArguments(
 const std::vector<std::string>& aArgs
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  fIteratorArgs = aArgs;
}
//////////////////////////////////////////////////////////////////////////////
const std::vector<std::string>& Lib::BaseAccessor::iteratorArguments(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fIteratorArgs;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::BaseAccessor::setExecuteArguments(
 const std::vector<std::string>& aArgs
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  fExecuteArgs = aArgs;
}
//////////////////////////////////////////////////////////////////////////////
const std::vector<std::string>& Lib::BaseAccessor::executeArguments(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fExecuteArgs;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::BaseAccessor::destroy(
 Slash::Data::IAccessor::Data
,void*
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
void Lib::BaseAccessor::set(
 Slash::Data::IAccessor::Data
,const std::string&
,const std::string&
,void*
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
void Lib::BaseAccessor::calculate(
 Slash::Data::IAccessor::Data
,const std::string&
,const std::vector<Slash::Core::IValue*>&
,void*
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
void Lib::BaseAccessor::clearProperties(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fList.clear();
}
//////////////////////////////////////////////////////////////////////////////
Slash::Core::IWriter& Lib::BaseAccessor::printer(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fPrinter;
}
