// this :
#include <Lib/FileWriter.h>

#include <Lib/Out.h>
#include <Lib/Debug.h>

#include <stdio.h>
//////////////////////////////////////////////////////////////////////////////
Lib::FileWriter::FileWriter(
 const std::string& aFileName
,Slash::Core::IWriter& aPrinter
)
:fPrinter(aPrinter)
,fFileName(aFileName)
,fFILE(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("Lib::FileWriter");
  fFILE = ::fopen(aFileName.c_str(),"wb");
}
//////////////////////////////////////////////////////////////////////////////
Lib::FileWriter::~FileWriter(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(fFILE) ::fclose((FILE*)fFILE);
  Lib::Debug::decrement("Lib::FileWriter");
}
//////////////////////////////////////////////////////////////////////////////
void Lib::FileWriter::disable(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fFILE) return; // Already closed.
  ::fclose((FILE*)fFILE);
  fFILE = 0;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::FileWriter::enable(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(fFILE) return; // Already open.
  fFILE = ::fopen(fFileName.c_str(),"wb");
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::FileWriter::enabled(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fFILE ? true : false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::FileWriter::write(
 const std::string& aString
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fFILE) return false;
  if(::fprintf((FILE*)fFILE,"%s",aString.c_str())<0) {
    Lib::Out out(fPrinter);
    out << "Lib::FileWriter::write :"
        << " error writing in file \"" << fFileName 
        << "\"." << Lib::endl;
    disable();
    return false;
  } else {
    return true;
  }
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::FileWriter::flush(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fFILE) return false;
  if(::fflush((FILE*)fFILE)!=0) return false;
  return true;
}
