#ifndef lint
static const char Processor_sccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20050813

#define YYEMPTY (-1)
#define Processor_clearin    (Processor_char = YYEMPTY)
#define Processor_errok      (Processor_errflag = 0)
#define YYRECOVERING (Processor_errflag != 0)

extern int Processor_parse(void);

static int Processor_growstack(void);
#define YYPREFIX "Processor_"
#line 2 "../source/Processor.y"

/* this :*/
#include <Lib/Processor.h>

#include <Slash/Core/IWriter.h>
#include <Lib/Out.h>
#include <Lib/ProcessorLexer.h>
#include <Lib/smanip.h>
#include <Lib/sout.h>

static Lib::Processor* sParser = 0;

extern int ProcessorLexer_lex();
int Processor_parse();
static void Processor_error(char*); 

#define NotFound (-1)

/*#define DEBUG*/

#line 24 "../source/Processor.y"
typedef union {
  unsigned int fIndex;
  unsigned int fInteger;
  double fNumber;
  Lib::Expression* fExpression;
} YYSTYPE;
#line 50 "y.tab.c"
#define STRG 257
#define T_NAME 258
#define NUMBER_INTEGER 259
#define NUMBER_REAL 260
#define T_COS 261
#define T_SIN 262
#define T_TAN 263
#define T_ACOS 264
#define T_ASIN 265
#define T_ATAN 266
#define T_SQRT 267
#define T_POW 268
#define T_LOG 269
#define T_LOG10 270
#define T_EXP 271
#define T_FABS 272
#define T_COSH 273
#define T_SINH 274
#define T_TANH 275
#define T_GAUSS 276
#define T_BW 277
#define T_EXPO 278
#define T_POL1 279
#define T_POL2 280
#define T_POL3 281
#define T_POL4 282
#define T_CAUCHY 283
#define T_TOINT 284
#define T_MOD 285
#define T_ARRAY 286
#define T_NCO 287
#define T_VSUM 288
#define T_RNDM 289
#define T_PI 290
#define T_TRUE 291
#define T_FALSE 292
#define T_AND 293
#define T_OR 294
#define UMINUS 295
#define YYERRCODE 256
short Processor_lhs[] = {                                        -1,
    0,    0,    0,    1,    1,    1,    1,    1,    1,    1,
    2,    2,    2,    2,    2,    2,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,
};
short Processor_len[] = {                                         2,
    1,    1,    1,    2,    4,    3,    4,    3,    3,    1,
    3,    4,    3,    4,    4,    4,    3,    3,    3,    4,
    3,    2,    3,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    6,    4,    4,    4,    4,   10,   10,
   10,    8,    8,   10,   12,   14,    4,    6,    8,    4,
    4,    4,    1,    1,    1,    1,    1,    1,    1,
};
short Processor_defred[] = {                                      0,
    1,   59,   58,   56,   57,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   53,   54,   55,    0,    0,    0,
    0,    0,   10,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   22,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    9,   23,    0,    0,    0,    0,    0,    0,   21,
    0,   19,    0,    0,    0,    0,    0,    0,   24,   25,
   26,   30,   31,   32,   33,    0,   35,   36,   37,   38,
   27,   28,   29,    0,    0,    0,    0,    0,    0,    0,
    0,   47,    0,    0,   50,   51,   52,    0,    0,   20,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   34,    0,    0,    0,    0,
    0,    0,    0,    0,   48,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   42,   43,    0,
    0,    0,    0,   49,    0,    0,    0,    0,    0,    0,
   39,   40,   44,    0,    0,   41,    0,    0,   45,    0,
    0,   46,
};
short Processor_dgoto[] = {                                      41,
   42,   43,   77,
};
short Processor_sindex[] = {                                    -33,
    0,    0,    0,    0,    0,  -38,  -37,  -36,  -35,  -27,
  -26,  -25,  -10,   -8,   -2,    7,    9,   40,   43,   44,
   45,   46,   58,   60,   62,   65,   66,   67,   71,   73,
   81,   83,   89,   91,    0,    0,    0,  256,   79,   79,
    0,  -30,    0,   54,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,    0,  -30,   54,  -32,   48,   79,
   79,   -9,  -84,  256,  256,  256,  115,   16,  151,   72,
  220,   85,   94,  102,  121,  128,  135,  142,  -22,  152,
  159,  166,  173,  225,  232,  241,  255,  263,  271,  634,
  654,  672,  678,  684,  403,  704,  721,  410,  417,  424,
  509,    0,    0,  -30,  -30,   79,   79,  -11,  -11,    0,
  256,    0,  256,  256,   75,  256,  256,   75,    0,    0,
    0,    0,    0,    0,    0,  256,    0,    0,    0,    0,
    0,    0,    0,  256,  256,  256,  256,  256,  256,  256,
  256,    0,  256,  256,    0,    0,    0,  -30,  -30,    0,
   75,   75,   75,   75,  516,  733,  739,  745,  751,  757,
  763,  769,  775,  523,  781,    0,  256,  256,  256,  256,
  256,  256,  256,  256,    0,  256,  787,  793,  530,  537,
  799,  805,  811,  817,  583,  256,  256,    0,    0,  256,
  256,  256,  256,    0,  600,  607,  614,  823,  829,  621,
    0,    0,    0,  256,  256,    0,  628,  835,    0,  256,
  646,    0,
};
short Processor_rindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   50,    0,   88,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   11,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   19,   24,    0,    0,    1,   10,    0,
    0,    0,    0,    0,   18,    0,    0,   26,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   27,   33,    0,
   28,   35,   37,   41,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,
};
short Processor_gindex[] = {                                      0,
  -23,    0,  549,
};
#define YYTABLESIZE 882
short Processor_table[] = {                                      39,
   18,   45,   46,   47,   48,   82,   40,   82,  122,   17,
    4,   38,   49,   50,   51,   76,   78,   11,    6,   87,
   85,  146,   84,    8,   86,   13,    5,   16,  126,   52,
   87,   53,    7,   18,   12,   86,   15,   54,   18,  127,
   14,   18,   17,   18,   18,   18,   55,   17,   56,    2,
   17,    4,   17,   17,   17,   11,  124,  125,   11,    6,
   18,   18,   18,   13,    8,   16,   13,    5,   16,   17,
   17,   17,   12,    7,   15,   12,  133,   15,   14,   57,
   88,   14,   58,   59,   60,   61,   88,    3,  123,   87,
   85,   83,   84,   83,   86,   87,   85,   62,   84,   63,
   86,   64,  168,  169,   65,   66,   67,   91,   90,   89,
   68,   39,   69,   91,   90,   89,   87,   85,   40,   84,
   70,   86,   71,   38,   18,  139,   87,   85,   72,   84,
   73,   86,  136,   17,  140,   87,   85,    0,   84,    0,
   86,   11,  141,   87,   85,    0,   84,    0,   86,   13,
    0,   16,    0,    0,   74,    0,  131,    0,   12,   38,
   15,  142,   87,   85,   14,   84,    0,   86,  143,   87,
   85,    0,   84,    0,   86,  144,   87,   85,    0,   84,
    0,   86,  145,   87,   85,    0,   84,    0,   86,    0,
   74,    0,  147,   87,   85,   38,   84,    0,   86,  148,
   87,   85,    0,   84,    0,   86,  149,   87,   85,    0,
   84,  134,   86,  150,   87,   85,    0,   84,    0,   86,
    0,    0,    1,    2,    3,    4,    5,    6,    7,    8,
    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,   33,   34,   35,   36,   37,   74,
   80,   81,   80,   81,   38,  151,   87,   85,    0,   84,
    0,   86,  152,   87,   85,    0,   84,    0,   86,    0,
  137,  153,   87,   85,    0,   84,    0,   86,    0,    0,
    0,    0,    0,   18,   18,   74,   87,   85,  154,   84,
   38,   86,   17,   17,   87,   85,  155,   84,    0,   86,
   11,   11,   87,   85,  156,   84,    0,   86,   13,   13,
   16,   16,    0,    0,    0,    0,    0,   12,   12,   15,
   15,    0,    0,   14,   14,    2,    3,    4,    5,    6,
    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
   37,    2,    3,    4,    5,    6,    7,    8,    9,   10,
   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,   33,   34,   35,   36,   37,    2,    3,    4,
    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
   35,   36,   37,  162,   87,   85,    0,   84,    0,   86,
  165,   87,   85,    0,   84,    0,   86,  166,   87,   85,
    0,   84,    0,   86,  167,   87,   85,    0,   84,    0,
   86,    0,    0,    0,    0,    0,    2,    3,    4,    5,
    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
   36,   37,    2,    3,    4,    5,    6,    7,    8,    9,
   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,   33,   34,   35,   36,   37,   44,  123,
   87,   85,    0,   84,    0,   86,  186,   87,   85,    0,
   84,    0,   86,  195,   87,   85,    0,   84,    0,   86,
  208,   87,   85,    0,   84,    0,   86,  209,   87,   85,
    0,   84,    0,   86,    0,    0,   75,    0,   79,    0,
    0,    0,    0,   92,   93,   94,   95,   96,   97,   98,
   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,
  109,  110,  111,  112,  113,  114,  115,  116,  117,  118,
  119,  120,  121,  214,   87,   85,    0,   84,    0,   86,
    0,    0,  128,  129,  130,  132,    0,  135,    0,  138,
  221,   87,   85,    0,   84,    0,   86,  222,   87,   85,
    0,   84,    0,   86,  223,   87,   85,    0,   84,    0,
   86,  226,   87,   85,    0,   84,    0,   86,  229,   87,
   85,    0,   84,    0,   86,   87,   85,  157,   84,  170,
   86,  171,  172,    0,  173,  174,  232,   87,   85,    0,
   84,    0,   86,    0,  175,   87,   85,  158,   84,    0,
   86,    0,  176,  177,  178,  179,  180,  181,  182,  183,
    0,  184,  185,   87,   85,  159,   84,    0,   86,   87,
   85,  160,   84,    0,   86,   87,   85,  161,   84,    0,
   86,    0,    0,    0,    0,  197,  198,  199,  200,  201,
  202,  203,  204,    0,  205,   87,   85,  163,   84,    0,
   86,    0,    0,    0,  215,  216,    0,    0,  217,  218,
  219,  220,   87,   85,  164,   84,    0,   86,    0,    0,
    0,    0,  227,  228,   87,   85,  187,   84,  231,   86,
   87,   85,  188,   84,    0,   86,   87,   85,  189,   84,
    0,   86,   87,   85,  190,   84,    0,   86,   87,   85,
  191,   84,    0,   86,   87,   85,  192,   84,    0,   86,
   87,   85,  193,   84,    0,   86,   87,   85,  194,   84,
    0,   86,   87,   85,  196,   84,    0,   86,   87,   85,
  206,   84,    0,   86,   87,   85,  207,   84,    0,   86,
   87,   85,  210,   84,    0,   86,   87,   85,  211,   84,
    0,   86,   87,   85,  212,   84,    0,   86,   87,   85,
  213,   84,    0,   86,   87,   85,  224,   84,    0,   86,
   87,   85,  225,   84,    0,   86,   87,   85,  230,   84,
    0,   86,
};
short Processor_check[] = {                                      33,
    0,   40,   40,   40,   40,   38,   40,   38,   41,    0,
    0,   45,   40,   40,   40,   39,   40,    0,    0,   42,
   43,   44,   45,    0,   47,    0,    0,    0,   38,   40,
   42,   40,    0,   33,    0,   47,    0,   40,   38,  124,
    0,   41,   33,   43,   44,   45,   40,   38,   40,    0,
   41,   41,   43,   44,   45,   38,   80,   81,   41,   41,
   60,   61,   62,   38,   41,   38,   41,   41,   41,   60,
   61,   62,   38,   41,   38,   41,   61,   41,   38,   40,
   33,   41,   40,   40,   40,   40,   33,    0,   41,   42,
   43,  124,   45,  124,   47,   42,   43,   40,   45,   40,
   47,   40,  126,  127,   40,   40,   40,   60,   61,   62,
   40,   33,   40,   60,   61,   62,   42,   43,   40,   45,
   40,   47,   40,   45,  124,   41,   42,   43,   40,   45,
   40,   47,   61,  124,   41,   42,   43,   -1,   45,   -1,
   47,  124,   41,   42,   43,   -1,   45,   -1,   47,  124,
   -1,  124,   -1,   -1,   40,   -1,   42,   -1,  124,   45,
  124,   41,   42,   43,  124,   45,   -1,   47,   41,   42,
   43,   -1,   45,   -1,   47,   41,   42,   43,   -1,   45,
   -1,   47,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   40,   -1,   41,   42,   43,   45,   45,   -1,   47,   41,
   42,   43,   -1,   45,   -1,   47,   41,   42,   43,   -1,
   45,   61,   47,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,  256,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,   40,
  293,  294,  293,  294,   45,   41,   42,   43,   -1,   45,
   -1,   47,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   61,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,  293,  294,   40,   42,   43,   44,   45,
   45,   47,  293,  294,   42,   43,   44,   45,   -1,   47,
  293,  294,   42,   43,   44,   45,   -1,   47,  293,  294,
  293,  294,   -1,   -1,   -1,   -1,   -1,  293,  294,  293,
  294,   -1,   -1,  293,  294,  257,  258,  259,  260,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,   41,   42,   43,   -1,   45,   -1,   47,
   41,   42,   43,   -1,   45,   -1,   47,   41,   42,   43,
   -1,   45,   -1,   47,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,    0,   41,
   42,   43,   -1,   45,   -1,   47,   41,   42,   43,   -1,
   45,   -1,   47,   41,   42,   43,   -1,   45,   -1,   47,
   41,   42,   43,   -1,   45,   -1,   47,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   38,   -1,   40,   -1,
   -1,   -1,   -1,   45,   46,   47,   48,   49,   50,   51,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
   72,   73,   74,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   84,   85,   86,   87,   -1,   89,   -1,   91,
   41,   42,   43,   -1,   45,   -1,   47,   41,   42,   43,
   -1,   45,   -1,   47,   41,   42,   43,   -1,   45,   -1,
   47,   41,   42,   43,   -1,   45,   -1,   47,   41,   42,
   43,   -1,   45,   -1,   47,   42,   43,   44,   45,  131,
   47,  133,  134,   -1,  136,  137,   41,   42,   43,   -1,
   45,   -1,   47,   -1,  146,   42,   43,   44,   45,   -1,
   47,   -1,  154,  155,  156,  157,  158,  159,  160,  161,
   -1,  163,  164,   42,   43,   44,   45,   -1,   47,   42,
   43,   44,   45,   -1,   47,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,  187,  188,  189,  190,  191,
  192,  193,  194,   -1,  196,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,  206,  207,   -1,   -1,  210,  211,
  212,  213,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,  224,  225,   42,   43,   44,   45,  230,   47,
   42,   43,   44,   45,   -1,   47,   42,   43,   44,   45,
   -1,   47,   42,   43,   44,   45,   -1,   47,   42,   43,
   44,   45,   -1,   47,   42,   43,   44,   45,   -1,   47,
   42,   43,   44,   45,   -1,   47,   42,   43,   44,   45,
   -1,   47,   42,   43,   44,   45,   -1,   47,   42,   43,
   44,   45,   -1,   47,   42,   43,   44,   45,   -1,   47,
   42,   43,   44,   45,   -1,   47,   42,   43,   44,   45,
   -1,   47,   42,   43,   44,   45,   -1,   47,   42,   43,
   44,   45,   -1,   47,   42,   43,   44,   45,   -1,   47,
   42,   43,   44,   45,   -1,   47,   42,   43,   44,   45,
   -1,   47,
};
#define YYFINAL 41
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 295
#if YYDEBUG
char *Processor_name[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,0,"'&'",0,"'('","')'","'*'","'+'","','","'-'",0,"'/'",0,0,0,0,0,0,0,
0,0,0,0,0,"'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'|'",0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,"STRG","T_NAME","NUMBER_INTEGER","NUMBER_REAL","T_COS",
"T_SIN","T_TAN","T_ACOS","T_ASIN","T_ATAN","T_SQRT","T_POW","T_LOG","T_LOG10",
"T_EXP","T_FABS","T_COSH","T_SINH","T_TANH","T_GAUSS","T_BW","T_EXPO","T_POL1",
"T_POL2","T_POL3","T_POL4","T_CAUCHY","T_TOINT","T_MOD","T_ARRAY","T_NCO",
"T_VSUM","T_RNDM","T_PI","T_TRUE","T_FALSE","T_AND","T_OR","UMINUS",
};
char *Processor_rule[] = {
"$accept : result",
"result : error",
"result : comparisons",
"result : expression",
"comparisons : '!' comparisons",
"comparisons : comparisons '&' '&' comparisons",
"comparisons : comparisons T_AND comparisons",
"comparisons : comparisons '|' '|' comparisons",
"comparisons : comparisons T_OR comparisons",
"comparisons : '(' comparisons ')'",
"comparisons : comparison",
"comparison : expression '>' expression",
"comparison : expression '>' '=' expression",
"comparison : expression '<' expression",
"comparison : expression '<' '=' expression",
"comparison : expression '=' '=' expression",
"comparison : expression '!' '=' expression",
"expression : expression '+' expression",
"expression : expression '-' expression",
"expression : expression '*' expression",
"expression : expression '*' '*' expression",
"expression : expression '/' expression",
"expression : '-' expression",
"expression : '(' expression ')'",
"expression : T_COS '(' expression ')'",
"expression : T_SIN '(' expression ')'",
"expression : T_TAN '(' expression ')'",
"expression : T_COSH '(' expression ')'",
"expression : T_SINH '(' expression ')'",
"expression : T_TANH '(' expression ')'",
"expression : T_ACOS '(' expression ')'",
"expression : T_ASIN '(' expression ')'",
"expression : T_ATAN '(' expression ')'",
"expression : T_SQRT '(' expression ')'",
"expression : T_POW '(' expression ',' expression ')'",
"expression : T_LOG '(' expression ')'",
"expression : T_LOG10 '(' expression ')'",
"expression : T_EXP '(' expression ')'",
"expression : T_FABS '(' expression ')'",
"expression : T_GAUSS '(' expression ',' expression ',' expression ',' expression ')'",
"expression : T_BW '(' expression ',' expression ',' expression ',' expression ')'",
"expression : T_CAUCHY '(' expression ',' expression ',' expression ',' expression ')'",
"expression : T_EXPO '(' expression ',' expression ',' expression ')'",
"expression : T_POL1 '(' expression ',' expression ',' expression ')'",
"expression : T_POL2 '(' expression ',' expression ',' expression ',' expression ')'",
"expression : T_POL3 '(' expression ',' expression ',' expression ',' expression ',' expression ')'",
"expression : T_POL4 '(' expression ',' expression ',' expression ',' expression ',' expression ',' expression ')'",
"expression : T_TOINT '(' expression ')'",
"expression : T_MOD '(' expression ',' expression ')'",
"expression : T_ARRAY '(' expression ',' expression ',' expression ')'",
"expression : T_NCO '(' expression ')'",
"expression : T_VSUM '(' expression ')'",
"expression : T_RNDM '(' expression ')'",
"expression : T_PI",
"expression : T_TRUE",
"expression : T_FALSE",
"expression : NUMBER_INTEGER",
"expression : NUMBER_REAL",
"expression : T_NAME",
"expression : STRG",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      Processor_debug;
int      Processor_nerrs;
int      Processor_errflag;
int      Processor_char;
short   *Processor_ssp;
YYSTYPE *Processor_vsp;
YYSTYPE  Processor_val;
YYSTYPE  Processor_lval;

/* variables for the parser stack */
static short   *Processor_ss;
static short   *Processor_sslim;
static YYSTYPE *Processor_vs;
static int      Processor_stacksize;
#line 803 "../source/Processor.y"
//////////////////////////////////////////////////////////////////////////////
Lib::Processor::Processor(
 const std::string& aString
,Slash::Core::IWriter& aPrinter
) 
:fString(aString)
,fPrinter(aPrinter)
,fFindNames(false)
,fLexer(aPrinter)
,fResult(0)
,fSuccess(false)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib::Processor::~Processor(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  clear();
}
//////////////////////////////////////////////////////////////////////////////
Lib::Processor& Lib::Processor::operator=(
 const Processor& aProcessor
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  clear();
  fLexer = aProcessor.fLexer;
  // Reset other things :
  fString = "";
  fFindNames = false;
  fResult = 0;
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Processor::setScript(
 const std::string& aString
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  clear();
  fString = aString;
  fFindNames = false;
  fResult = 0;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Processor::clear(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  for(unsigned int index=0;index<fTmpExps.size();index++) 
    delete fTmpExps[index];
  fTmpExps.clear();
  fNames.clear();
  delete fResult;
  fResult = 0;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Processor::findVariables(
 std::vector<std::string>& aNames
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  aNames.clear();
  clear();
  if(!fString.size()) return true;
  fLexer.set(fString);
  fFindNames = true;
  sParser = this;
  fSuccess = true;
  Processor_parse();
  sParser = 0;
  if(!fSuccess) {
    clear();
    return false;
  }
  if(fTmpExps.size()) {
    Lib::Out out(fPrinter);
    out << "Lib::Processor::findVariables :"
        << " stack anomaly " << (unsigned int)fTmpExps.size()
        << Lib::endl;
  }
  smanip::unique(fNames);
  aNames = fNames;
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Processor::compile(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<std::string> vars;
  findVariables(vars);
  return compile(vars);
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Processor::compile(
 const std::vector<std::string>& aNames
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  clear();
  if(!fString.size()) return true;
  fNames = aNames;
  fLexer.set(fString);
  fFindNames = false;
  sParser = this;
  fSuccess = true;
  Processor_parse();
  sParser = 0;
  if(!fSuccess) {
    clear();
    return false;
  }
  if(fTmpExps.size()) {
    Lib::Out out(fPrinter);
    out << "Lib::Processor::compile :"
        << " stack anomaly " << (unsigned int)fTmpExps.size()
        << Lib::endl;
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Processor::execute(
 const std::vector<Lib::Value>& aInput
,Lib::Value& aResult
,std::string& aError
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //printf("debug : Lib::Processor::execute : \"%s\" %lu\n",
  //  fString.c_str(),fResult);
  if(!fString.size()) {
    aResult.setNone();
    return true;
  }
  if(!fResult) {
    aResult.setNone();
    aError = "Lib::Processor::execute : not ready : fReturn = 0.";
    return false;
  }
  if(!fResult->execute(aInput,aError)) {
    aResult.setNone();
    return false;
  }
  if(!fSuccess) {
    aResult.setNone();
    aError = "Lib::Processor::execute : failed.";
    return false;
  }
  aResult = fResult->ret();
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Processor::cut(
 const std::vector<Lib::Value>& aInput
,bool& aResult
,std::string& aError
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Value ret; //WARNING : this allocation can take time.
  if(!execute(aInput,ret,aError)) {
    aResult = true;
    return false;
  }
  if(ret.type()==Slash::Core::IValue::BOOL) {
    aResult = ret.get_bool();
    return true;
  }
  if(ret.type()==Slash::Core::IValue::NONE) { 
    //This may happen if fString is empty.
    aResult = true;
    return true;
  }
  aResult = true;
  aError = "Lib::Processor::cut : failed.";
  return false;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Processor::addName(
 const std::string& aString
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fNames.push_back(aString);
}
//////////////////////////////////////////////////////////////////////////////
Slash::Core::IWriter& Lib::Processor::printer(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fPrinter;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Processor::findNames(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fFindNames;
}
//////////////////////////////////////////////////////////////////////////////
const Lib::ProcessorLexer& Lib::Processor::lexer(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fLexer;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Processor::findVariable(
 const std::string& aString
,unsigned int& aIndex
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!smanip::lineIndex(fNames,aString,aIndex)) {
    Lib::Out out(fPrinter);
    out << " " << aString << " not a variable." << Lib::endl;
    return false;
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////////
std::vector<Lib::Expression*>& Lib::Processor::stack(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fTmpExps;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Processor::setResult(
 Lib::Expression* aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fResult = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Processor::setStatus(
 bool aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fSuccess = aValue;
}
//////////////////////////////////////////////////////////////////////////////
static void Processor_error(
 char* aString
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(sParser) {
    Lib::Out out(sParser->printer());
    out << "Processor : " << aString << Lib::endl;
    sParser->setStatus(false);
  }
}
#line 768 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int Processor_growstack(void)
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = Processor_stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = Processor_ssp - Processor_ss;
    newss = (Processor_ss != 0)
          ? (short *)realloc(Processor_ss, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    Processor_ss  = newss;
    Processor_ssp = newss + i;
    newvs = (Processor_vs != 0)
          ? (YYSTYPE *)realloc(Processor_vs, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    Processor_vs = newvs;
    Processor_vsp = newvs + i;
    Processor_stacksize = newsize;
    Processor_sslim = Processor_ss + newsize - 1;
    return 0;
}

#define YYABORT goto Processor_abort
#define YYREJECT goto Processor_abort
#define YYACCEPT goto Processor_accept
#define YYERROR goto Processor_errlab
int
Processor_parse(void)
{
    register int Processor_m, Processor_n, Processor_state;
#if YYDEBUG
    register const char *Processor_s;

    if ((Processor_s = getenv("YYDEBUG")) != 0)
    {
        Processor_n = *Processor_s;
        if (Processor_n >= '0' && Processor_n <= '9')
            Processor_debug = Processor_n - '0';
    }
#endif

    Processor_nerrs = 0;
    Processor_errflag = 0;
    Processor_char = YYEMPTY;

    if (Processor_ss == NULL && Processor_growstack()) goto Processor_overflow;
    Processor_ssp = Processor_ss;
    Processor_vsp = Processor_vs;
    *Processor_ssp = Processor_state = 0;

Processor_loop:
    if ((Processor_n = Processor_defred[Processor_state]) != 0) goto Processor_reduce;
    if (Processor_char < 0)
    {
        if ((Processor_char = ProcessorLexer_lex()) < 0) Processor_char = 0;
#if YYDEBUG
        if (Processor_debug)
        {
            Processor_s = 0;
            if (Processor_char <= YYMAXTOKEN) Processor_s = Processor_name[Processor_char];
            if (!Processor_s) Processor_s = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, Processor_state, Processor_char, Processor_s);
        }
#endif
    }
    if ((Processor_n = Processor_sindex[Processor_state]) && (Processor_n += Processor_char) >= 0 &&
            Processor_n <= YYTABLESIZE && Processor_check[Processor_n] == Processor_char)
    {
#if YYDEBUG
        if (Processor_debug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, Processor_state, Processor_table[Processor_n]);
#endif
        if (Processor_ssp >= Processor_sslim && Processor_growstack())
        {
            goto Processor_overflow;
        }
        *++Processor_ssp = Processor_state = Processor_table[Processor_n];
        *++Processor_vsp = Processor_lval;
        Processor_char = YYEMPTY;
        if (Processor_errflag > 0)  --Processor_errflag;
        goto Processor_loop;
    }
    if ((Processor_n = Processor_rindex[Processor_state]) && (Processor_n += Processor_char) >= 0 &&
            Processor_n <= YYTABLESIZE && Processor_check[Processor_n] == Processor_char)
    {
        Processor_n = Processor_table[Processor_n];
        goto Processor_reduce;
    }
    if (Processor_errflag) goto Processor_inrecovery;

    Processor_error("syntax error");

#ifdef lint
    goto Processor_errlab;
#endif

Processor_errlab:
    ++Processor_nerrs;

Processor_inrecovery:
    if (Processor_errflag < 3)
    {
        Processor_errflag = 3;
        for (;;)
        {
            if ((Processor_n = Processor_sindex[*Processor_ssp]) && (Processor_n += YYERRCODE) >= 0 &&
                    Processor_n <= YYTABLESIZE && Processor_check[Processor_n] == YYERRCODE)
            {
#if YYDEBUG
                if (Processor_debug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *Processor_ssp, Processor_table[Processor_n]);
#endif
                if (Processor_ssp >= Processor_sslim && Processor_growstack())
                {
                    goto Processor_overflow;
                }
                *++Processor_ssp = Processor_state = Processor_table[Processor_n];
                *++Processor_vsp = Processor_lval;
                goto Processor_loop;
            }
            else
            {
#if YYDEBUG
                if (Processor_debug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *Processor_ssp);
#endif
                if (Processor_ssp <= Processor_ss) goto Processor_abort;
                --Processor_ssp;
                --Processor_vsp;
            }
        }
    }
    else
    {
        if (Processor_char == 0) goto Processor_abort;
#if YYDEBUG
        if (Processor_debug)
        {
            Processor_s = 0;
            if (Processor_char <= YYMAXTOKEN) Processor_s = Processor_name[Processor_char];
            if (!Processor_s) Processor_s = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, Processor_state, Processor_char, Processor_s);
        }
#endif
        Processor_char = YYEMPTY;
        goto Processor_loop;
    }

Processor_reduce:
#if YYDEBUG
    if (Processor_debug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, Processor_state, Processor_n, Processor_rule[Processor_n]);
#endif
    Processor_m = Processor_len[Processor_n];
    Processor_val = Processor_vsp[1-Processor_m];
    switch (Processor_n)
    {
case 1:
#line 52 "../source/Processor.y"
{
  /* To reset lex and yacc in case of error.*/
}
break;
case 2:
#line 54 "../source/Processor.y"
{
  if(sParser->findNames()) {
    sParser->setResult(0);
  } else {
    sParser->setResult(Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
  }
}
break;
case 3:
#line 61 "../source/Processor.y"
{
  if(sParser->findNames()) {
    sParser->setResult(0);
  } else {
    sParser->setResult(Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
  }
}
break;
case 4:
#line 71 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : ! cps" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::NOT,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 5:
#line 83 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : cps && cps" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::AND,Processor_vsp[-3].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 6:
#line 96 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : cps && cps" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::AND,Processor_vsp[-2].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 7:
#line 109 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : cps || cps" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::OR,Processor_vsp[-3].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 8:
#line 122 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : cps || cps" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::OR,Processor_vsp[-2].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 9:
#line 135 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : (cps)" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::ASSIGN,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 10:
#line 147 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : cp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::ASSIGN,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 11:
#line 162 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : exp > exp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::GT,Processor_vsp[-2].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 12:
#line 175 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : exp >= exp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::GE,Processor_vsp[-3].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 13:
#line 188 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : exp < exp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::LT,Processor_vsp[-2].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 14:
#line 201 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : exp <= exp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::LE,Processor_vsp[-3].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 15:
#line 214 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : exp == exp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::EQ,Processor_vsp[-3].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 16:
#line 227 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : exp != exp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::NE,Processor_vsp[-3].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 17:
#line 243 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : exp + exp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::ADD,Processor_vsp[-2].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 18:
#line 256 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : exp - exp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::SUB,Processor_vsp[-2].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 19:
#line 269 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : exp * exp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::MUL,Processor_vsp[-2].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 20:
#line 282 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : exp ** exp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::POW,Processor_vsp[-3].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 21:
#line 295 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : exp / exp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::DIV,Processor_vsp[-2].fExpression,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 22:
#line 308 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : - exp" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::MINUS,Processor_vsp[0].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 23:
#line 320 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : (exp)" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::ASSIGN,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 24:
#line 332 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_COS" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::COS,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 25:
#line 344 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_SIN" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::SIN,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 26:
#line 356 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_TAN" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::TAN,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 27:
#line 368 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_COSH" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::COSH,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 28:
#line 380 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_SINH" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::SINH,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 29:
#line 392 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_TANH" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::TANH,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 30:
#line 404 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_ACOS" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::ACOS,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 31:
#line 416 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_ASIN" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::ASIN,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 32:
#line 428 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_ATAN" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::ATAN,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 33:
#line 440 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_SQRT" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::SQRT,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 34:
#line 452 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_POW" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::POW,Processor_vsp[-3].fExpression,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 35:
#line 465 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_LOG" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::LOG,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 36:
#line 477 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_LOG10" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::LOG10,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 37:
#line 489 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_EXP" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::EXP,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 38:
#line 501 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_FABS" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::FABS,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 39:
#line 513 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_GAUSS" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::GAUSS,Processor_vsp[-7].fExpression,Processor_vsp[-5].fExpression,Processor_vsp[-3].fExpression,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 40:
#line 528 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_BW" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::BW,Processor_vsp[-7].fExpression,Processor_vsp[-5].fExpression,Processor_vsp[-3].fExpression,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 41:
#line 543 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_CAUCHY" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::CAUCHY,Processor_vsp[-7].fExpression,Processor_vsp[-5].fExpression,Processor_vsp[-3].fExpression,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 42:
#line 558 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_EXPO" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::EXPO,Processor_vsp[-5].fExpression,Processor_vsp[-3].fExpression,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 43:
#line 572 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_POL1" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::POL1,Processor_vsp[-5].fExpression,Processor_vsp[-3].fExpression,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 44:
#line 586 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_POL2" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::POL2,Processor_vsp[-7].fExpression,Processor_vsp[-5].fExpression,Processor_vsp[-3].fExpression,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 45:
#line 601 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_POL3" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::POL3,Processor_vsp[-9].fExpression,Processor_vsp[-7].fExpression,Processor_vsp[-5].fExpression,Processor_vsp[-3].fExpression,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 46:
#line 617 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_POL4" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::POL4,Processor_vsp[-11].fExpression,Processor_vsp[-9].fExpression,Processor_vsp[-7].fExpression,Processor_vsp[-5].fExpression,Processor_vsp[-3].fExpression,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 47:
#line 634 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_TOINT" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::TOINT,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 48:
#line 646 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_MOD" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::MOD,Processor_vsp[-3].fExpression,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 49:
#line 659 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_ARRAY " << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::ARRAY,Processor_vsp[-5].fExpression,Processor_vsp[-3].fExpression,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 50:
#line 673 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_NCO" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::NCO,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 51:
#line 685 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_VSUM" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::VSUM,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 52:
#line 697 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_VSUM" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::FUNC,Lib::Expression::RNDM,Processor_vsp[-1].fExpression);
    sParser->stack().pop_back();
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 53:
#line 709 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_PI" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::PI);
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 54:
#line 720 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_TRUE" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::BOOL_TRUE);
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 55:
#line 731 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_FALSE" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::BOOL_FALSE);
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 56:
#line 742 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : NUMBER_INTEGER" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression
      (Lib::Expression::UNSIGNED_INTEGER,(unsigned int)Processor_vsp[0].fInteger);
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 57:
#line 754 "../source/Processor.y"
{ 
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : NUMBER_REAL" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::REAL,Processor_vsp[0].fNumber);
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
case 58:
#line 765 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : T_NAME" << Lib::endl;
#endif
  if(sParser->findNames()) {
    sParser->addName(sParser->lexer().variable(Processor_vsp[0].fIndex));
    Processor_val.fExpression = 0;
  } else {
    std::string var = sParser->lexer().variable(Processor_vsp[0].fIndex);
    unsigned int index;
    if(sParser->findVariable(var,index)) {
      Processor_val.fExpression = new Lib::Expression(Lib::Expression::NAME,var,int(index));
      sParser->stack().push_back(Processor_val.fExpression);
    } else {
      /*Lib::Out out(sParser->printer());*/
      /*out << "debug : Processor.y :"*/
      /*    << " findVariable failed for " << Lib::sout(var) << "."*/
      /*    << Lib::endl;*/
      Processor_val.fExpression = new Lib::Expression(Lib::Expression::NAME,var,NotFound);
      sParser->stack().push_back(Processor_val.fExpression);
    }
  }
}
break;
case 59:
#line 788 "../source/Processor.y"
{
#ifdef DEBUG
  Lib::Out out(sParser->printer());
  out << "debug : Processor.y : STRG" << Lib::endl;
#endif
  if(sParser->findNames()) {
    Processor_val.fExpression = 0;
  } else {
    Processor_val.fExpression = new Lib::Expression(Lib::Expression::STRING,
                             sParser->lexer().variable(Processor_vsp[0].fIndex));
    sParser->stack().push_back(Processor_val.fExpression);
  }
}
break;
#line 1921 "y.tab.c"
    }
    Processor_ssp -= Processor_m;
    Processor_state = *Processor_ssp;
    Processor_vsp -= Processor_m;
    Processor_m = Processor_lhs[Processor_n];
    if (Processor_state == 0 && Processor_m == 0)
    {
#if YYDEBUG
        if (Processor_debug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        Processor_state = YYFINAL;
        *++Processor_ssp = YYFINAL;
        *++Processor_vsp = Processor_val;
        if (Processor_char < 0)
        {
            if ((Processor_char = ProcessorLexer_lex()) < 0) Processor_char = 0;
#if YYDEBUG
            if (Processor_debug)
            {
                Processor_s = 0;
                if (Processor_char <= YYMAXTOKEN) Processor_s = Processor_name[Processor_char];
                if (!Processor_s) Processor_s = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, Processor_char, Processor_s);
            }
#endif
        }
        if (Processor_char == 0) goto Processor_accept;
        goto Processor_loop;
    }
    if ((Processor_n = Processor_gindex[Processor_m]) && (Processor_n += Processor_state) >= 0 &&
            Processor_n <= YYTABLESIZE && Processor_check[Processor_n] == Processor_state)
        Processor_state = Processor_table[Processor_n];
    else
        Processor_state = Processor_dgoto[Processor_m];
#if YYDEBUG
    if (Processor_debug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *Processor_ssp, Processor_state);
#endif
    if (Processor_ssp >= Processor_sslim && Processor_growstack())
    {
        goto Processor_overflow;
    }
    *++Processor_ssp = Processor_state;
    *++Processor_vsp = Processor_val;
    goto Processor_loop;

Processor_overflow:
    Processor_error("yacc stack overflow");

Processor_abort:
    return (1);

Processor_accept:
    return (0);
}
