// this :
#include <Lib/cxx.h>

#include <string.h>

//Lib::cxx(typeid(NM1::NM1_X))

std::string __typeName(char*&  name) {
  if ( *name == 'Q' ) {              // Handle name spaces
    if ( *(++name) == '_' )          // >= 10 nested name spaces
      ::strtol(++name, &name, 10);   // type Q_##_...
    return __className(++name); 
  }
  else if ( 't' == *name )  {
    return __className(name); 
  }
  else  {
    std::string result;
    char* ptr;
    int i = ::strtol(name, &ptr, 10);
    if ( i <= 0 )  {
      name = ptr;
      while ( *name != 0 && *name != 'Z' )  {
	if ( *name == 'U' )  {
	  result += "unsigned ";
	  name++;
	}
	switch( *name++ )  {
	case 'c': result += "char"; break;
	case 's': result += "short"; break;
	case 'i': result += "int"; break;
	case 'l': result += "long"; break;
	case 'f': result += "float"; break;
	case 'd': result += "double"; break;
	default:  result += *(name-1);
	}
      }
      return result;
    }
    else {
      return __className(name); 
    }
  }
}

//////////////////////////////////////////////////////////////////////////////
bool Lib::cxx(
 const std::type_info& aTID
,std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
#ifdef _WIN32
  long off = 0;
  const char* class_name = aTID.name();
  if ( ::strncmp(class_name, "class ", 6) == 0 )   {
    // The returned name is prefixed with "class "
    off = 6;
  }
  if ( ::strncmp(class_name, "struct ", 7) == 0 )   {
    // The returned name is prefixed with "struct "
    off = 7;
  }
  if ( off > 0 )    {
    std::string tmp = class_name + off;
    long loc = 0;
    while( (loc = tmp.find("class ")) > 0 )  {
      tmp.erase(loc, 6);
    }
    loc = 0;
    while( (loc = tmp.find("struct ")) > 0 )  {
      tmp.erase(loc, 7);
    }
    aValue = tmp;
    return true;
  } else  {
    aValue = aTID.name();
    return true;
  }
#elif defined(sun)
  aValue = aTID.name();
  return true;
#elif defined(__linux) || defined(__APPLE__)
  //#ifdef GCC ?
  std::string result;
  #if __GNUC__ <= 2
    // Old method coded by Markus Frank
    char* name = const_cast<char*>(aTID.name());
    aValue = __typeName( name );
  #else
    int status;
    char* realname = abi::__cxa_demangle(aTID.name(), 0, 0, &status);
    aValue = realname;
    free(realname);
    /// substitute ', ' with ','  
    std::string::size_type pos = aValue.find(", ");
    while( std::string::npos != pos ) {
      aValue.replace( pos , 2 , "," ) ;
      pos = aValue.find(", ");
    }
  #endif
  return true;
#else
  return false;
#endif
}
