
#include <Lib/smanip.h>
#include <Lib/fmanip.h>
#include <Lib/dirmanip.h>
#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/Debug.h>

#include <stdio.h>

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgs
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Printer printer;
  {
    Lib::Out out(printer);

    std::string tmpName;
    if(!Lib::fmanip::tmpname(tmpName,".","Lib_tmp","")) {
      out << "Can't build a temporary directory name." << Lib::endl;
      return 0;
    }

    if(!Lib::dirmanip::create(tmpName)) {
      out << "Can't create \"" << tmpName << "\" directory." << Lib::endl;
      return 0;
    }

    std::string fileName = tmpName + "/" + tmpName + "_0";
    FILE* file = ::fopen(fileName.c_str(),"w+");
    ::fprintf(file,"test");
    ::fclose(file);
    fileName = tmpName + "/" + tmpName + "_1";
    file = ::fopen(fileName.c_str(),"w+");
    ::fprintf(file,"test");
    ::fclose(file);

    // Analyse the content of the directory :
    std::vector<std::string> files;
    if(!Lib::dirmanip::entries(tmpName,files)) {
      out << "Can't get files in \"" << tmpName 
          << "\" directory." << Lib::endl;
      return 0;
    }

    std::string srm = aArgc>=2 ? aArgs[1] : "-rm";
    if(srm=="-rm") {
      // Remove the temporary directory :
      if(!Lib::dirmanip::remove(tmpName)) {
        out << "Can't remove \"" << tmpName << "\" directory." << Lib::endl;
        return 0;
      }
    }

    for(unsigned int i=0;i<files.size();i++) {
      out << files[i] << Lib::endl;
    }


   {std::string dir_root;
    if(!Lib::dirmanip::binaryPath(aArgs[0],dir_root)) {
      out << "Can't get binary path of " << aArgs[0]
          << Lib::endl;
    } else {
      out << " binary path of " << aArgs[0]
          << " is " << dir_root
          << Lib::endl;
    }}

  }Lib::Debug::balance(printer);

  return 0;
}
