
#include <Lib/smanip.h>
#include <Lib/fmanip.h>
#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/sout.h>

#include <Lib/System.h>
#include <Lib/dirmanip.h>
#include <Lib/Debug.h>

//////////////////////////////////////////////////////////////////////////////
int main (
 int //aArgc
,char** //aArgs
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Printer printer;
  {
    Lib::Out out(printer);
    
    if(!Lib::dirmanip::goHome()) {
      out << "Lib_home :"
          << " can't go in home directory."
          << Lib::endl;
      return Lib::System::exitFailure();
    }    

    std::string dir;
    Lib::dirmanip::directory(dir);
    out << "Lib_home :"
        << " pwd " << Lib::sout(dir)
        << Lib::endl;

    if(!Lib::dirmanip::mkcd("Documents")) {
      out << "Lib_home :"
          << " can't go in directory Documents."
          << Lib::endl;
      return Lib::System::exitFailure();      
    }

    Lib::dirmanip::directory(dir);
    out << "Lib_home :"
        << " pwd " << Lib::sout(dir)
        << Lib::endl;

    if(!Lib::dirmanip::mkcd("Lib")) {
      out << "Lib_home :"
          << " can't go in directory Lib."
          << Lib::endl;
      return Lib::System::exitFailure();      
    }
 
    Lib::dirmanip::directory(dir);
    out << "Lib_home :"
        << " pwd " << Lib::sout(dir)
        << Lib::endl;

    std::vector<std::string> text;
    text.push_back("Hello");
    Lib::fmanip::write("Lib.log",text);    

  }Lib::Debug::balance(printer);

  return Lib::System::exitSuccess();
}
