// this :
#include <RandGauss.h>

#include <stdlib.h>
#include <math.h>

RandGauss::RandGauss(double aMean,double aSigma):fMean(aMean),fSigma(aSigma){}
double RandGauss::fire() const {
  double v1,v2,r,fac;
  double flat1,flat2;
  do {
    flat1 = ((double)::rand())/((double)RAND_MAX);
    flat2 = ((double)::rand())/((double)RAND_MAX);
    v1 = 2.0 * flat1 - 1.0;
    v2 = 2.0 * flat2 - 1.0;
    r = v1*v1 + v2*v2;
  } while ( r > 1.0 );
  fac = ::sqrt(-2.0*::log(r)/r);
  return (v2 * fac) * fSigma + fMean;
}
