@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version @@obuild_version@@
REM # for the package @@package@@ with version @@version@@.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\project\version\obuild
REM #   DOS> DOS\build_release
REM # or :
REM #   DOS> call DOS\build_release.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET @@path_variable@@=%~dp0
REM # Remove ending \obuild\DOS\
SET @@path_variable@@=%@@path_variable@@:~0,-12%

SET obuild_verbose=no
SET obuild_set_x=no
SET obuild_erase_dir_bin=no

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   DOS\run [Options]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -x : execute with ECHO ON"
  ECHO   -e : erase binary directory.
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-e" GOTO end_if_e
  SET obuild_erase_dir_bin=yes
  SHIFT
  GOTO next_arg
:end_if_e

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF "%OBUILD_DIR_BIN%" == "" (
  SET @@dir_bin_variable@@=bin_obuild
) ELSE (
  SET @@dir_bin_variable@@=%OBUILD_DIR_BIN%
)

IF "%@@dir_bin_variable@@%" == "" (
  ECHO @@dir_bin_variable@@ variable not defined.
  GOTO obuild_return
)

IF "%obuild_erase_dir_bin%" == "yes" (
  IF EXIST "@@dir_bin@@" RMDIR /S /Q "@@dir_bin@@"
  GOTO obuild_return
)

IF NOT EXIST "@@dir_bin@@" MKDIR "@@dir_bin@@"

