@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package zip with version v1r101p0.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\build_zip_minizip
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_zip_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_zip_path=%obuild_zip_path:~0,-12%

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

SET obuild_verbose=no
SET obuild_debug=no
SET obuild_optimize=yes
SET obuild_set_x=no

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug=yes
  SHIFT
  GOTO next_arg
:end_if_g

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF %obuild_debug% == yes SET obuild_optimize=no

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%" MKDIR "%obuild_zip_path%\%obuild_dir_bin%"

IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%" MKDIR "%obuild_zip_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_zip_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_zip_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_zip_0=%%d
cd "%obuild_zip_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_zip_0%"
SET obuild_pwd_zip_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_1
SET obuild_c_command=cl.exe
:end_if_platform_1
SET obuild_platform_result=
IF "%obuild_c_command%" == ""  ECHO Variable obuild_c_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_zip_0=%%d
cd "%obuild_zip_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_zip_0%"
SET obuild_pwd_zip_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_3
SET obuild_c_optimize=/O2
:end_if_platform_3
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_zip_0=%%d
cd "%obuild_zip_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_zip_0%"
SET obuild_pwd_zip_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_5
SET obuild_c_debug=/ZI /Od
:end_if_platform_5
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_zip_0=%%d
cd "%obuild_zip_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_zip_0%"
SET obuild_pwd_zip_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_7
SET obuild_c_options=/nologo /DWIN32 /MD /W3
:end_if_platform_7
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_app_zip_minizip_sh_8
  SET obuild_c_debug_local=%obuild_c_debug%
  GOTO end_if_db_build_app_zip_minizip_sh_8
:else_if_db_build_app_zip_minizip_sh_8
  SET obuild_c_debug_local=
:end_if_db_build_app_zip_minizip_sh_8

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_app_zip_minizip_sh_9
  SET obuild_c_optimize_local=%obuild_c_optimize%
  GOTO end_if_opt_build_app_zip_minizip_sh_9
:else_if_opt_build_app_zip_minizip_sh_9
  SET obuild_c_optimize_local=
:end_if_opt_build_app_zip_minizip_sh_9


IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%" MKDIR "%obuild_zip_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_zip_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_zip_path%\obuild\cpp\obuild_find.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_zip_0=%%d
cd "%obuild_zip_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r*`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_zip_0%"
SET obuild_pwd_zip_0=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_zip_0=%%d
cd "%obuild_zip_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r*`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_zip_0%"
SET obuild_pwd_zip_0=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

SET obuild_c_includes=/I"%obuild_zlib_path%\include"
SET obuild_c_includes=%obuild_c_includes% /I"%obuild_zip_path%\include"

IF EXIST "%obuild_zip_path%\%obuild_dir_bin%\app_zip_minizip" RMDIR /S /Q "%obuild_zip_path%\%obuild_dir_bin%\app_zip_minizip"
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\app_zip_minizip" MKDIR "%obuild_zip_path%\%obuild_dir_bin%\app_zip_minizip"

@IF %obuild_verbose% == yes @ECHO ON 
cd "%obuild_zip_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\app_zip_minizip\minizip.obj "..\applications\minizip\minizip.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_zip_path%\obuild"

cd "%obuild_zip_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\app_zip_minizip\mztools.obj "..\applications\minizip\mztools.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_zip_path%\obuild"

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_zip_0=%%d
cd "%obuild_zip_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_zip_0%"
SET obuild_pwd_zip_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_16
cd "%obuild_zip_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\app_zip_minizip\iowin32.obj "..\applications\minizip\iowin32.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_zip_path%\obuild"

:end_if_platform_16
SET obuild_platform_result=
@IF %obuild_verbose% == yes @ECHO OFF 

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_zip_0=%%d
cd "%obuild_zip_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_zip_0%"
SET obuild_pwd_zip_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_18
SET obuild_c_linker_command=link.exe
:end_if_platform_18
SET obuild_platform_result=
IF "%obuild_c_linker_command%" == ""  ECHO Variable obuild_c_linker_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_zip_0=%%d
cd "%obuild_zip_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_zip_0%"
SET obuild_pwd_zip_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_20
SET obuild_c_linker_debug=/DEBUG
:end_if_platform_20
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_zip_0=%%d
cd "%obuild_zip_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_zip_0%"
SET obuild_pwd_zip_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_22
SET obuild_c_linker_options=/nologo
:end_if_platform_22
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_app_zip_minizip_sh_23
  SET obuild_c_linker_debug_local=%obuild_c_linker_debug%
  GOTO end_if_db_build_app_zip_minizip_sh_23
:else_if_db_build_app_zip_minizip_sh_23
  SET obuild_c_linker_debug_local=
:end_if_db_build_app_zip_minizip_sh_23

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_app_zip_minizip_sh_24
  SET obuild_c_linker_optimize_local=%obuild_c_linker_optimize%
  GOTO end_if_opt_build_app_zip_minizip_sh_24
:else_if_opt_build_app_zip_minizip_sh_24
  SET obuild_c_linker_optimize_local=
:end_if_opt_build_app_zip_minizip_sh_24

SET obuild_linked_paths=/LIBPATH:"%obuild_zip_path%\%obuild_dir_bin%"
SET obuild_linked_libraries=osc_zip.lib
SET obuild_linked_paths=%obuild_linked_paths% /LIBPATH:"%obuild_zlib_path%\%obuild_dir_bin%"
SET obuild_linked_libraries=%obuild_linked_libraries% osc_zlib.lib

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_zip_0=%%d
cd "%obuild_zip_path%\%obuild_dir_bin%"
IF EXIST .\app_zip_minizip\tmp_objs DEL .\app_zip_minizip\tmp_objs
FOR %%f IN (.\app_zip_minizip\*.obj) DO ECHO %%f >> .\app_zip_minizip\tmp_objs
REM # Link zip_minizip :
IF EXIST .\zip_minizip.exe DEL .\zip_minizip.exe
@IF %obuild_verbose% == yes @ECHO ON 
%obuild_c_linker_command% %obuild_c_linker_debug_local% %obuild_c_linker_optimize_local% %obuild_c_linker_options% /out:.\zip_minizip.exe @.\app_zip_minizip\tmp_objs %obuild_linked_paths% %obuild_linked_libraries%
@IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 

cd "%obuild_pwd_zip_0%"
SET obuild_pwd_zip_0=
REM # Some cleanup :
IF EXIST "%obuild_zip_path%\%obuild_dir_bin%\app_zip_minizip\tmp_objs" DEL "%obuild_zip_path%\%obuild_dir_bin%\app_zip_minizip\tmp_objs"
IF EXIST "%obuild_zip_path%\%obuild_dir_bin%\zip_minizip.ilk" DEL "%obuild_zip_path%\%obuild_dir_bin%\zip_minizip.ilk"
IF EXIST "%obuild_zip_path%\%obuild_dir_bin%\zip_minizip.pdb" DEL "%obuild_zip_path%\%obuild_dir_bin%\zip_minizip.pdb"
IF EXIST "%obuild_zip_path%\%obuild_dir_bin%\app_zip_minizip\tmp_objs" DEL "%obuild_zip_path%\%obuild_dir_bin%\app_zip_minizip\tmp_objs"
IF EXIST "%obuild_zip_path%\%obuild_dir_bin%\zip_minizip.exp" DEL "%obuild_zip_path%\%obuild_dir_bin%\zip_minizip.exp"

:obuild_return
ENDLOCAL
@ECHO ON
